



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>BZOJ 3207 花神的嘲讽计划Ⅰ（函数式线段树）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">BZOJ 3207 花神的嘲讽计划Ⅰ（函数式线段树）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 04:28:46 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题目链接：<a href="http://61.187.179.132/JudgeOnline/problem.php?id=3207" rel="external nofollow noreferrer">http://61.187.179.132/JudgeOnline/problem.php?id=3207</a></p>
<p>题意：给出一个数列，若干询问。每个询问查询[L,R]区间内是否存在某个长度为K的子数列（连续的）。</p>
<p>思路：将长度为K的每个子数列哈希成一个值，将查询也哈希成一个值，建立函数式线段树，然后对于查询[L,R]，查询个数是否大于0。</p>
<p>int n,m,K,a[N];<br />int st[N],ed[N];<br />u64 b[N],bNum;<br />u64 p[N],q[N];</p>
<p>u64 getHash(int L,int R)<br />{<br />&nbsp; &nbsp; u64 ans=0;<br />&nbsp; &nbsp; int i;<br />&nbsp; &nbsp; for(i=L;i&lt;=R;i++) ans=ans*107+a[i];<br />&nbsp; &nbsp; return ans;<br />}</p>
<p>struct node<br />{<br />&nbsp; &nbsp; int L,R,a,b,s;<br />};</p>
<p>node tree[N&lt;&lt;4];<br />int root[N],tot;</p>
<p>int build(int a,int b)<br />{<br />&nbsp; &nbsp; int k=++tot;<br />&nbsp; &nbsp; tree[k].a=a;<br />&nbsp; &nbsp; tree[k].b=b;<br />&nbsp; &nbsp; tree[k].s=0;<br />&nbsp; &nbsp; int mid=(a+b)&gt;&gt;1;<br />&nbsp; &nbsp; if(a!=b)<br />&nbsp; &nbsp; {<br />&nbsp; &nbsp; &nbsp; &nbsp; tree[k].L=build(a,mid);<br />&nbsp; &nbsp; &nbsp; &nbsp; tree[k].R=build(mid+1,b);<br />&nbsp; &nbsp; }<br />&nbsp; &nbsp; return k;<br />}</p>
<p>int insert(int p,int x)<br />{<br />&nbsp; &nbsp; int k=++tot;<br />&nbsp; &nbsp; tree[k]=tree[p];<br />&nbsp; &nbsp; tree[k].s++;<br />&nbsp; &nbsp; if(tree[k].a==x&amp;&amp;tree[k].b==x) return k;<br />&nbsp; &nbsp; int mid=(tree[k].a+tree[k].b)&gt;&gt;1;<br />&nbsp; &nbsp; if(x&lt;=mid) tree[k].L=insert(tree[p].L,x);<br />&nbsp; &nbsp; else tree[k].R=insert(tree[p].R,x);<br />&nbsp; &nbsp; return k;<br />}</p>
<p>int get(int p,int x)<br />{<br />&nbsp; &nbsp; if(tree[p].a==tree[p].b) return tree[p].s;<br />&nbsp; &nbsp; int mid=(tree[p].a+tree[p].b)&gt;&gt;1;<br />&nbsp; &nbsp; if(x&lt;=mid) return get(tree[p].L,x);<br />&nbsp; &nbsp; else get(tree[p].R,x);<br />}</p>
<p>int main()<br />{<br />&nbsp; &nbsp; RD(n,m,K);<br />&nbsp; &nbsp; int i;<br />&nbsp; &nbsp; FOR1(i,n) RD(a[i]);<br />&nbsp; &nbsp; bNum=n-K+1;<br />&nbsp; &nbsp; FOR1(i,bNum) p[i]=b[i]=getHash(i,i+K-1);<br />&nbsp; &nbsp; int j,x;<br />&nbsp; &nbsp; u64 t;<br />&nbsp; &nbsp; FOR1(i,m)<br />&nbsp; &nbsp; {<br />&nbsp; &nbsp; &nbsp; &nbsp; RD(st[i],ed[i]); ed[i]=ed[i]-K+1;<br />&nbsp; &nbsp; &nbsp; &nbsp; t=0;<br />&nbsp; &nbsp; &nbsp; &nbsp; FOR1(j,K) RD(x),t=t*107+x;<br />&nbsp; &nbsp; &nbsp; &nbsp; q[i]=b[++bNum]=t;<br />&nbsp; &nbsp; }<br />&nbsp; &nbsp; sort(b+1,b+bNum+1);<br />&nbsp; &nbsp; root[0]=build(1,bNum);<br />&nbsp; &nbsp; FOR1(i,n-K+1)<br />&nbsp; &nbsp; {<br />&nbsp; &nbsp; &nbsp; &nbsp; a[i]=lower_bound(b+1,b+bNum+1,p[i])-b;<br />&nbsp; &nbsp; &nbsp; &nbsp; root[i]=insert(root[i-1],a[i]);<br />&nbsp; &nbsp; }<br />&nbsp; &nbsp; FOR1(i,m)<br />&nbsp; &nbsp; {<br />&nbsp; &nbsp; &nbsp; &nbsp; x=lower_bound(b+1,b+bNum+1,q[i])-b;<br />&nbsp; &nbsp; &nbsp; &nbsp; if(get(root[ed[i]],x)-get(root[st[i]-1],x)&gt;0) puts("No");<br />&nbsp; &nbsp; &nbsp; &nbsp; else puts("Yes");<br />&nbsp; &nbsp; }<br />}</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqljvke9.html">iOS 之UIButton左文右图</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gp1we9.html">从头开始搭建分布式日志平台的docker环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwre2y9.html">&period;net frameworkAPI文档下载地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p21nk8.html">转使用chrome命令行：disable-web-security 实现浏览器跨域</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde0ez09.html">Activity之间的数据传递</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd54vgq.html">Query classification&semi; understanding user intent</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w37lwq.html">我的第一款Cocos2d 游戏小狗快跑基本完成</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1kplz9.html">利用python建表</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rde3k48.html">winform  &mdash;&mdash; 连接数据库SQL Server 2008</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge5k0z8.html">Spring&plus;SpringMVC&plus;MyBatis深入学习及搭建&lpar;四&rpar;&mdash;&mdash;MyBatis输入映射与输出映射</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gexxol8.html">正则表达式 cheat sheet</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zwwv39.html">AI&lowbar;深度学习为何兴起？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkv1yv8.html">Swift PlayGround无限Running问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8megpepq.html">解决Docker安装MySQL不区分大小写问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw0n3z9.html">数列全排列问题----递归实现--JAVA</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvvmxk8.html">基于线程开发一个FTP服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdzkvj9.html">BASIC GIT WORKFLOW</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdvkzj9.html">&lbrack;Leetcode 100&rsqb;判断二叉树相同 Same Tree</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl5lvl9.html">java调用存储过程mysql</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1v0yk9.html">POJ 2377</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rd1gm48.html">Ubuntu中NetBeans C&sol;C&plus;&plus;配置、编译</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j02z44q.html">帝国cms后台不停的登录成功</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvre1zq.html">VS2013中自动缩进和注释的快捷键</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xw35v8.html">DRLSE 水平集算法总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnwlw2q.html">sqlserver insert into select</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnwwe0q.html">一些css效果积累</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oyyey9.html">Oracle 临时事务表 全局临时表&lowbar;global temporary table</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm55ol9.html">&lbrack;nowCoder&rsqb; 完全二叉树结点数</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1v2jj9.html">Eclipse下PHP开发 插件安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xwdde8.html">uva 757</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
